///////
     //
     //  MOBOTIX EventStream Client SDK 
     //
     //  See LICENSE_SDK included in the SDK package
     //
     //  Copyright (c) 2005 - 2016, MOBOTIX AG
     //  All rights reserved.
     //
///////
    

#ifndef M1IMAGE_JSIMAGE_SRC_MXPEG_SINKAUDIO_HPP_
#define M1IMAGE_JSIMAGE_SRC_MXPEG_SINKAUDIO_HPP_

#include "MxPEG_Audio.hpp"
#include <vector>

namespace ie { namespace MxPEG
{

class MxPEG_SinkAudio
{
public:
   MxPEG_SinkAudio ();

   virtual
   ~MxPEG_SinkAudio ();

   MxPEG_ReturnCode consumeAudio(MxPEG_Audio *buffer);

   /*
    * Called by the SDK if an audio stream end notification is sent by the camera.
    */
   virtual
   MxPEG_ReturnCode closeAudioDevice() = 0;

   /*
    * Called if the SDK detects an incoming audio stream.
    */
   virtual
   MxPEG_ReturnCode initAudioDevice() = 0;

   /*
    * Specifies the audio format expected by this sink. See doGetTargetFormat()
    */
   MxPEG_AudioFormat * targetFormat();

protected:
   friend class MxPEG_SinkSynchronized;

   /*
    * Receives each audio frame right after it was decoded.
    *
    * doConsumeAudio needs to take care of deleting the buffer once it is no longer needed.
    */
   virtual
   MxPEG_ReturnCode doConsumeAudio(MxPEG_Audio *buffer) = 0;

   /*
    * Returns the audio format that is expected by the sink.
    *
    * Naturally the camera sends audio data as PCM16, 16kHz, mono stream. The SDK has some (limited) conversion
    * capabilities, use this to specify the desired output.
    */
   virtual
   MxPEG_AudioFormat * doGetTargetFormat() = 0;

};

}} /* namespace ie::MxPEG */

#endif /* M1IMAGE_JSIMAGE_SRC_MXPEG_SINKAUDIO_HPP_ */
